Compare commits

...

29 Commits
v2.8 ... master

Author SHA1 Message Date
Jack L. Frost 4939405926 ABS is not using SVN anymore
Signed-off-by: fbt <fbt@fleshless.org>
2023-10-26 14:54:30 +00:00
Jack L. Frost e9bdb6b4e1 rpc url
Signed-off-by: fbt <fbt@fleshless.org>
2022-02-14 22:20:00 +03:00
Jack L. Frost df42e43a49 just create the dir 2016-04-01 13:19:52 +03:00
Jack L. Frost 7fedda7342 Should probably feed pacman the package name
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-17 02:29:43 +03:00
Alad Wenter cdc83819f5 Use pacman -Sp for figuring out the repo a package is in
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-17 02:27:46 +03:00
Alad Wenter 96b7584153 Use one jshon call for search results
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-17 02:25:32 +03:00
Jack L. Frost aacf420a68 There is no more tarball
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-01 08:32:19 +03:00
Alad Wenter 56a2817649 Fix jshon calls
Signed-off-by: fbt <fbt@fleshless.org>
2016-02-29 18:49:49 +03:00
Alad Wenter 97d6852e92 Use RPC v5
Signed-off-by: fbt <fbt@fleshless.org>
2016-02-29 18:41:08 +03:00
Jack L. Frost 04ec3a81a5 README also 2015-09-25 18:15:58 +03:00
Jack L. Frost 8db246e7af help update 2015-09-25 18:14:45 +03:00
Jack L. Frost c13a3a3fdc support for downloading updated packages 2015-09-25 18:12:04 +03:00
Jack L. Frost 0b62cf2bc4 Don't query AUR for each package dammit 2015-09-25 17:56:23 +03:00
Jack L. Frost 351a03c515 update! 2015-09-23 18:05:45 +03:00
Jack L. Frost 8e2ed7b9f9 Update usage and README 2015-09-21 14:18:24 +03:00
Jack L. Frost e7252333b0 A few improvements:
* Use the new RPC format to avoid sourcing the PKGBUILD.
* A separate switch for curl's insecure mode: --nossl.
* Clone the AUR git repos instead of downloading the targballs.
2015-09-21 14:14:54 +03:00
Jack L. Frost 0496e2c887 there is one AUR now 2015-08-09 15:55:10 +03:00
Jack L. Frost a450ff9708 use aur4 by default 2015-06-22 13:31:03 +03:00
Jack L. Frost dd0d7f7902 support AUR 4 2015-06-10 14:15:52 +03:00
Jack L. Frost 840ab9254c export instead of checkout 2015-05-22 17:53:16 +03:00
Jack L. Frost b2dc6c01d7 ughx2 2015-02-25 16:30:32 +03:00
Jack L. Frost c1490bb339 ugh 2015-02-25 16:22:45 +03:00
Jack L. Frost d26cd45116 rename the bloody script will ya 2015-02-25 16:20:42 +03:00
Jack L. Frost 73004f978c zpac is now PRM 2015-02-25 16:17:02 +03:00
Jack L. Frost 1c136aab43 Stop overriding echo, just use printf instead. 2015-02-20 17:50:36 +03:00
Jack L. Frost 4351aa9450 Code cleanup, thanks to [stronny](https://github.com/stronny) 2015-02-20 17:34:46 +03:00
Jack L. Frost d19dc0fbb1 readarray! 2015-02-20 16:43:53 +03:00
Jack L. Frost b2cb42c371 a better usage function 2015-02-20 16:16:15 +03:00
Jack L. Frost 95c0ffa43b better name foe the args normalizer 2015-02-13 12:20:45 +03:00
3 changed files with 365 additions and 312 deletions

View File

@ -1,16 +1,19 @@
zpac
----
prm
---
A very simple AUR/ABS helper. Doesn't build packages, only gets the sources.
Usage: zpac [flags] <package>
Flags:
-h Show this message.
-s Search for <package>.
-S Search only in the sync db. Implies -s.
-A Search only in AUR. Implies -s.
-d Get the package sources (default). Set twice to also get the dependencies.
-f Force downloading package sources even if they are already present in the working directory.
-w <dir> Set the working directory.
Usage: prm [flags] <package>
Flags:
-h Show this message.
-s Search for <package>.
-S Search only in the sync db. Implies -s.
-A Search only in AUR. Implies -s.
-d Get the package sources (default). Set twice to also get the dependencies.
-n Don't update existing git repos.
-u Print out all (and download if -d/-dd) outdated AUR packages.
-U <url> Set AUR url.
-w <dir> Set the working directory.
--nossl Set curl's --insecure flag.
You can override any value in the script in \$HOME/.config/zpac.rc.sh
By default zpac downloads the sources into the current directory. Controlled by `$cfg_workdir`.
You can override any value in the script in \$HOME/.config/prm.rc.sh
By default prm downloads the sources into the current directory. Controlled by `$cfg_workdir`.

349
prm Executable file
View File

@ -0,0 +1,349 @@
#!/usr/bin/env bash
# Author: Jack L. Frost <fbt@fleshless.org>
# Licensed under the Internet Software Consortium (ISC) license.
# See LICENSE for its text.
_self="${0##*/}"
cfg_workdir="$PWD"
cfg_aur_url="https://aur.archlinux.org"
cfg_curl_opts=( '--silent' '--location' )
err() { printf "$@" >&2; }
_cat() { while read -r; do printf '%s\n' "$REPLY"; done }
usage() {
_cat <<- EOF
Usage: $_self [flags] <package>
Flags:
-h Show this message.
-s Search for <package>.
-S Search only in the sync db. Implies -s.
-A Search only in AUR. Implies -s.
-d Get the package sources (default). Set twice to also get the dependencies.
-n Don't update existing git repos.
-u Print out all (and download if -d/-dd) outdated AUR packages.
-U <url> Set AUR url.
-w <dir> Set the working directory.
--nossl Set curl's --insecure flag.
EOF
}
aur.search() {
declare i aur_api_search_data aur_search_result_num version description
aur_api_search_data=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=search&arg=${1}" )
aur_search_result_num=$( jshon -e resultcount -u <<< "$aur_api_search_data" )
# Exit if nothing was found
(( aur_search_result_num )) || { return 1; }
while {
read -r name
read -r version
read -r description
} do
printf '%s %s\n %s\n' "aur/$name" "$version" "$description"
done < <( jshon -C -e results -a -e Name -u -p -e Version -u -p -e Description -u <<< "$aur_api_search_data" )
}
aur.info() {
declare pkg_aur_info aur_query_result
pkg_aur_info=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=info&arg=${1}" 2>/dev/null )
aur_query_result=$( jshon -e resultcount -u <<< "$pkg_aur_info" )
(( aur_query_result )) || { return 1; }
printf '%s' "$pkg_aur_info"
}
aur.get_updates() {
declare -a foreign_packages updated_pkgs
declare aur_api_multireq aur_api_data aur_api_data_length n p u n_name n_version l_name l_version
read -d '' -r -a foreign_packages < <( pacman -Qqm )
for p in "${foreign_packages[@]}"; do
aur_api_multireq+="&arg\[\]=$p"
done
aur_api_data=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=info${aur_api_multireq}" )
aur_api_data_length=$( jshon -e results -l <<< "$aur_api_data" )
(( aur_api_data_length-- ))
for (( n=0; n<=aur_api_data_length; n++ )); do
read -r n_name < <( jshon -e results -e "$n" -e Name -u <<< "$aur_api_data")
read -r n_version < <( jshon -e results -e "$n" -e Version -u <<< "$aur_api_data" )
read -r l_name l_version < <( pacman -Q "$n_name" )
if (( $(vercmp "$n_version" "$l_version") )); then
updated_pkgs+=( "$n_name" )
printf '%s\n' "$n_name"
fi
done
if ! (( ${#updated_pkgs[@]} )); then
printf 'No updates found\n'
return 0
fi
if (( flag_get )); then
for u in "${updated_pkgs[@]}"; do
aur.get < <( aur.info "$u" )
done
fi
}
aur.get() {
declare i pkg_aur_info pkg_base depends makedepends dep_name aur_api_multireq dep_name aur_deps_api_data aur_deps_count aur_deps
read -r pkg_aur_info
read -r pkg_base < <( jshon -e results -a -e Name -u <<< "$pkg_aur_info" )
cd "$cfg_workdir"
printf 'Working in %s\n' "${cfg_workdir}"
if [[ -d "$pkg_base" ]]; then
if ! (( flag_nopull )); then
printf 'Updating %s\n' "$pkg_base"
cd "$pkg_base"
git pull || {
err 'Fail!'
return 21
}
fi
else
printf 'Cloning %s\n' "$pkg_base"
git clone "https://aur.archlinux.org/${pkg_base}.git" || {
err 'Fail!'
return 19
}
fi
if (( flag_get_deps )); then
cd "${cfg_workdir}/${pkg_base}"
read -d '' -r -a depends < <(
jshon -Q -e results -a -e Depends -a -u <<< "$pkg_aur_info"
jshon -Q -e results -a -e MakeDepends -a -u <<< "$pkg_aur_info"
)
for i in "${depends[@]}"; do
dep_name="${i/[<>=]*}"
aur_api_multireq+="&arg\[\]=$dep_name"
done
aur_deps_api_data=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=info${aur_api_multireq}" )
aur_deps_count=$( jshon -e resultcount <<< "$aur_deps_api_data" )
if (( aur_deps_count )); then
printf "Getting dependencies for %s\n" "${pkg_base}"
aur_deps=( $( jshon -e results -a -e Name -u <<< "$aur_deps_api_data" ) )
for i in "${aur_deps[@]}"; do
aur.get < <(aur.info "$i")
_result="$?"
if (( _result > 0 && result != 17 )); then
return "$_result"
fi
done
fi
fi
}
abs.get() {
git clone "https://gitlab.archlinux.org/archlinux/packaging/packages/$1.git" "$cfg_workdir/$1"
}
set_argv() {
declare arg opt c
declare -g argv
while (( $# )); do
unset -v arg opt c
case "$1" in
(--) argv+=( "$1" ); break;;
(--*)
IFS='=' read arg opt <<< "$1"
argv+=( "$arg" )
[[ "$opt" ]] && {
argv+=( "$opt" )
}
;;
(-*)
while read -n1 c
do
case "$c" in
-|'') :;;
*) argv+=( "-$c" );;
esac
done <<< "$1"
;;
(*) argv+=( "$1" );;
esac
shift
done
}
main() {
if [[ -f "$HOME/.config/prm.rc.sh" ]]; then
source "$HOME/.config/prm.rc.sh"
fi
while (( $# )); do
case "$1" in
(--) shift; break;;
(-h) usage; return 0;;
(-s) flag_search=1;;
(-A)
flag_search=1
flag_search_aur=1;;
(-S)
flag_search=1
flag_search_syncdb=1;;
(-U)
cfg_aur_url="$2"
shift;;
(-u)
flag_update=1;;
(-d)
if (( flag_get )); then
flag_get_deps=1
else
flag_get=1
fi
;;
(-w)
cfg_workdir="$2"
shift;;
(-n) flag_nopull=1;;
(--nossl) cfg_curl_opts+=( '--insecure' );;
(-*)
err "Unknown key: %s\n" "$1"
usage
return 1
;;
(*) break;;
esac
shift
done
(( flag_search_aur && flag_search_syncdb )) && {
unset flag_search_aur flag_search_syncdb
}
cfg_aur_api="${cfg_aur_url}/rpc?v=5"
if (( flag_search )); then
action=search
elif (( flag_update )); then
action=update
elif (( flag_get )); then
action=get
fi
if [[ "$1" ]]; then
package="$1"
fi
[[ "$action" ]] || {
usage
return 1
}
[[ -d "$cfg_workdir" ]] || {
mkdir -p "$cfg_workdir" || {
err "Can't create workdir: %s\n" "$cfg_workdir"
return 1
}
}
case "$action" in
(get)
[[ "$package" ]] || {
usage
return 1
}
pkg_aur_info=$( aur.info "$package" )
if (( ! "$?" )); then
repo='aur'
else
read -r repo < <( pacman -Sp --print-format '%r' "$package" )
[[ "$repo" ]] || {
err "Can't find package %s\n" "$package"
return 1
}
fi
printf "Found %s in %s\n" "$package" "$repo"
case "$repo" in
(aur)
aur.get <<< "$pkg_aur_info";;
(core|extra|community|multilib)
abs.get "$package" "$repo";;
(*)
err "Repository %s not supported\n" "$repo"
return 1;;
esac
;;
(search)
[[ "$package" ]] || {
usage
return 1
}
if (( flag_search_aur )); then
aur.search "$package" || {
err "No packages found\n"
return 1
}
elif (( flag_search_syncdb )); then
pacman -Ss "$package"
else
aur.search "$package" || { flag_aur_search_fail=1; }
pacman -Ss "$package" 2>/dev/null || { flag_pacman_search_fail=1; }
if (( flag_aur_search_fail && flag_pacman_search_fail )); then
err "No packages found\n"
return 1
fi
fi
;;
(update)
aur.get_updates
;;
esac
}
set_argv "$@"
main "${argv[@]}"

299
zpac
View File

@ -1,299 +0,0 @@
#!/usr/bin/env bash
# Author: Jack L. Frost <fbt@fleshless.org>
# Licensed under the Internet Software Consortium (ISC) license.
# See LICENSE for its text.
_self="${0##*/}"
cfg_workdir="$PWD"
cfg_aur_url='https://aur.archlinux.org'
cfg_aur_api="${cfg_aur_url}/rpc.php"
echo() { printf '%s\n' "$*"; }
err() { echo "$*" >&2; }
usage() {
while read; do echo "$REPLY"; done <<- EOF
Usage: $_self [flags] <package>
Flags:
-h Show this message.
-s Search for <package>.
-S Search only in the sync db. Implies -s.
-A Search only in AUR. Implies -s.
-d Get the package sources (default). Set twice to also get the dependencies.
-f Force downloading package sources even if they are already present in the working directory.
-w <dir> Set the working directory.
EOF
}
aur.search() {
local aur_api_search_data aur_search_result_num pkg
aur_api_search_data=$( curl -skL "${cfg_aur_api}?type=search&arg=${1}" )
aur_search_result_num=$( jshon -e resultcount -u <<< "$aur_api_search_data" )
if (( aur_search_result_num )); then
aur_search_results=( $( jshon -e results -a -e Name -u <<< "$aur_api_search_data" ) )
for i in "${!aur_search_results[@]}"; do
{
read -r version
read -r description
} < <(
jshon -e results -e $i -e Version -u -p -e Description -u <<< "$aur_api_search_data"
)
printf '%s %s\n %s\n' "aur/${aur_search_results[$i]}" "$version" "$description"
done
else
return 1
fi
}
aur.info() {
local pkg_aur_info=$( curl -skL "${cfg_aur_api}?type=info&arg=${1}" 2>/dev/null )
local aur_query_result=$( jshon -e resultcount -u <<< "$pkg_aur_info" )
if (( aur_query_result )); then
echo "$pkg_aur_info"
else
return 1
fi
}
aur.get() {
local dep_name aur_api_multireq aur_deps_api_data aur_deps_count aur_deps pkg_aur_info pkg_base tarball_path
read -r pkg_aur_info
{
read -r pkg_base
read -r tarball_path
} < <(
jshon -e results -e PackageBase -u -p -e URLPath -u <<< "$pkg_aur_info"
)
(( flag_force )) || {
[[ -d "${cfg_workdir}/${pkg_base}" ]] && {
echo "Found ${pkg_base} in ${cfg_workdir}, skipping. Use -f to override."
return 17
}
}
cd "$cfg_workdir"
echo "Working in ${cfg_workdir}"
echo "Downloading ${pkg_base}"
{ curl -skL "${cfg_aur_url}${tarball_path}" | gzip -d | tar x; } || {
err "Fail!"
return 1
}
if (( flag_get_deps )); then
unset depends makedepends
cd "${cfg_workdir}/${pkg_base}"
source PKGBUILD
for i in "${depends[@]}" "${makedepends[@]}"; do
dep_name="${i/[<>=]*}"
aur_api_multireq+="&arg\[\]=$dep_name"
done
aur_deps_api_data=$( curl -skL "${cfg_aur_api}?type=multiinfo${aur_api_multireq}" )
aur_deps_count=$( jshon -e resultcount <<< "$aur_deps_api_data" )
if (( aur_deps_count )); then
echo "Getting dependencies for ${pkg_base}."
aur_deps=( $( jshon -e results -a -e Name -u <<< "$aur_deps_api_data" ) )
for i in "${aur_deps[@]}"; do
aur.get < <(aur.info "$i")
_result="$?"
(( _result )) && {
(( _result == 17 )) || {
return "$_result"
}
}
done
fi
fi
}
abs.get() {
local pkg_repo svn_repo
pkg_repo="$2"
case "$pkg_repo" in
(community|multilib)
svn_repo='community';;
(*)
svn_repo='packages';;
esac
svn checkout "svn://svn.archlinux.org/${svn_repo}/${1}/trunk" "${cfg_workdir}/${1}"
}
args_norm() {
declare arg opt c
declare -g argv
while (( $# )); do
unset -v arg opt c
case "$1" in
(--) argv+=( "$1" ); break;;
(--*)
IFS='=' read arg opt <<< "$1"
argv+=( "$arg" )
[[ "$opt" ]] && {
argv+=( "$opt" )
}
;;
(-*)
while read -n1 c
do
case "$c" in
-|'') :;;
*) argv+=( "-$c" );;
esac
done <<< "$1"
;;
(*) argv+=( "$1" );;
esac
shift
done
}
main() {
if [[ -f "$HOME/.config/zpac.rc.sh" ]]; then
source "$HOME/.config/zpac.rc.sh"
fi
while (( $# )); do
case "$1" in
(--) shift; break;;
(-h) usage; return 0;;
(-s) action='search';;
(-A)
action='search'
flag_search_aur=1;;
(-S)
action='search'
flag_search_syncdb=1;;
(-d)
if [[ "$action" == 'get' ]]; then
flag_get_deps=1
else
action='get'
fi
;;
(-w)
cfg_workdir="$2"
shift;;
(-f) flag_force=1;;
(-*)
err "Unknown key: $1"
usage
return 1
;;
(*) break;;
esac
shift
done
(( flag_search_aur && flag_search_syncdb )) && {
unset flag_search_aur flag_search_syncdb
}
[[ "$action" ]] || {
usage
return 1
}
if [[ "$1" ]]; then
package="$1"
else
usage
return 1
fi
case "$action" in
(get)
[[ -d "$cfg_workdir" ]] || {
mkdir -p "$cfg_workdir" || {
err "Can't create workdir: ${cfg_workdir}."
return 1
}
}
pkg_aur_info=$( aur.info "$package" )
if (( ! "$?" )); then
repo='aur'
else
while read -r; do
if [[ "$REPLY" =~ ^Repository ]]; then
repo="${REPLY##* }"
fi
done < <( pacman -Si "$package" )
[[ "$repo" ]] || {
err "Can't find package ${package}"
return 1
}
fi
echo "Found ${package} in ${repo}."
case "$repo" in
(aur)
aur.get <<< "$pkg_aur_info";;
(core|extra|community|multilib)
abs.get "$package" "$repo";;
(*)
err "Repository $repo not supported."
return 1;;
esac
;;
(search)
if (( flag_search_aur )); then
aur.search "$package" || {
err "No packages found."
return 1
}
elif (( flag_search_syncdb )); then
pacman -Ss "$package"
else
aur.search "$package" || { flag_aur_search_fail=1; }
pacman -Ss "$package" 2>/dev/null || { flag_pacman_search_fail=1; }
if (( flag_aur_search_fail && flag_pacman_search_fail )); then
err "No packages found."
return 1
fi
fi
;;
esac
}
args_norm "$@"
main "${argv[@]}"